HDOJ1018Big Number

简介: HDOJ1018Big Number

Problem Description

In many applications very large integers numbers are required. Some of these applications are using keys for secure transmission of data, encryption, etc. In this problem you are given a number, you have to determine the number of digits in the factorial of the number.


Input

Input consists of several lines of integer numbers. The first line contains an integer n, which is the number of cases to be tested, followed by n lines, one integer 1 ≤ n ≤ 107 on each line.


Output

The output contains the number of digits in the factorial of the integers appearing in the input.


Sample Input

2

10

20


Sample Output

7

19

/**
这题要求n的阶乘的位数,如果n较大时,n的阶乘必将是一个
很大的数,题中说1<=n<10000000,当n=10000000时可以说n
的阶乘将是一个非常巨大的数字,对于处理大数的问题,我
们一般用字符串,这题当n取最大值时,就是一千万个数字相
乘的积,太大了,就算保存在字符串中都有一点困难,而且
一千万个数字相乘是会涉及到大数的乘法,大数的乘法是比较
耗时的,就算计算出结果一般也会超时。这让我们不得不抛弃
这种直接的方法。
再想一下,这题是要求n的阶乘的位数,而n的阶乘是n个数的
乘积,那么要是我们能把这个问题分解就好了。
在这之前,我们必须要知道一个知识,任意一个正整数a的位数
等于(int)log10(a) + 1;为什么呢?下面给大家推导一下:
  对于任意一个给定的正整数a,
  假设10^(x-1)<=a<10^x,那么显然a的位数为x位,
  又因为
  log10(10^(x-1))<=log10(a)<(log10(10^x))
  即x-1<=log10(a)<x
  则(int)log10(a)=x-1,
  即(int)log10(a)+1=x
  即a的位数是(int)log10(a)+1
我们知道了一个正整数a的位数等于(int)log10(a) + 1,
现在来求n的阶乘的位数:
假设A=n!=1*2*3*......*n,那么我们要求的就是
(int)log10(A)+1,而:
    log10(A)
        =log10(1*2*3*......n)  (根据log10(a*b) = log10(a) + log10(b)有)
         =log10(1)+log10(2)+log10(3)+......+log10(n)
现在我们终于找到方法,问题解决了,我们将求n的阶乘的位
数分解成了求n个数对10取对数的和,并且对于其中任意一个数,
都在正常的数字范围之类。
总结一下:n的阶乘的位数等于
          (int)(log10(1)+log10(2)+log10(3)+......+log10(n)) + 1
根据这个思路我们很容易写出程序
**/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
int main()
{
    int n,m,i;
    scanf("%d",&n);
    while(n--)
    {
        double s=0;
        scanf("%d",&m);
        for(i=1;i<=m;i++)
        {
            s+=log10(i);
        }
        s=(int)(s+1);
        printf("%d\n",(int)s);
    }
    return 0;
}
目录
相关文章
|
算法
Leetcode 313. Super Ugly Number
题目翻译成中文是『超级丑数』,啥叫丑数?丑数就是素因子只有2,3,5的数,7 14 21不是丑数,因为他们都有7这个素数。 这里的超级丑数只是对丑数的一个扩展,超级丑数的素因子不再仅限于2 3 5,而是由题目给定一个素数数组。与朴素丑数算法相比,只是将素因子变了而已,解法还是和朴素丑数一致的。
98 1
|
5月前
|
存储 SQL 算法
LeetCode 题目 65:有效数字(Valid Number)【python】
LeetCode 题目 65:有效数字(Valid Number)【python】
|
6月前
|
存储 算法
【LeetCode力扣】单调栈解决Next Greater Number(下一个更大值)问题
【LeetCode力扣】单调栈解决Next Greater Number(下一个更大值)问题
42 0
|
存储
Leetcode Single Number II (面试题推荐)
给你一个整数数组,每个元素出现了三次,但只有一个元素出现了一次,让你找出这个数,要求线性的时间复杂度,不使用额外空间。
38 0
|
算法
LeetCode 414. Third Maximum Number
给定一个非空数组,返回此数组中第三大的数。如果不存在,则返回数组中最大的数。要求算法时间复杂度必须是O(n)。
93 0
LeetCode 414. Third Maximum Number
|
存储
LeetCode 313. Super Ugly Number
编写一段程序来查找第 n 个超级丑数。 超级丑数是指其所有质因数都是长度为 k 的质数列表 primes 中的正整数。
95 0
LeetCode 313. Super Ugly Number
|
算法
LeetCode 306. Additive Number
累加数是一个字符串,组成它的数字可以形成累加序列。 一个有效的累加序列必须至少包含 3 个数。除了最开始的两个数以外,字符串中的其他数都等于它之前两个数相加的和。 给定一个只包含数字 '0'-'9' 的字符串,编写一个算法来判断给定输入是否是累加数。 说明: 累加序列里的数不会以 0 开头,所以不会出现 1, 2, 03 或者 1, 02, 3 的情况。
121 0
LeetCode 306. Additive Number
|
算法
LeetCode 268. Missing Number
给定一个包含 0, 1, 2, ..., n 中 n 个数的序列,找出 0 .. n 中没有出现在序列中的那个数。
87 0
LeetCode 268. Missing Number
LeetCode 264. Ugly Number II
编写一个程序,找出第 n 个丑数。 丑数就是只包含质因数 2, 3, 5 的正整数。
70 0
LeetCode 264. Ugly Number II
LeetCode 263. Ugly Number
编写一个程序判断给定的数是否为丑数。 丑数就是只包含质因数 2, 3, 5 的正整数。
89 0
LeetCode 263. Ugly Number